/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Modelo;

import Otros.Diccionario;
import Otros.Visualizacion;
import java.util.ArrayList;
import maquinaEstados.maquinaEstados;

/**
 * Contiene todos los parámetros importantes para la creacion de los archivos de texto
 * @author Raúl Hernansanz Quevedo
 */
public class FuenteDeDatos {
    private static String rutaOrigen;
    private static String separador;
    private static String formatoDestino;
    private static String rutaDestino;
    private ArrayList<Visualizacion> visualizaciones;  
    private static Diccionario diccionario;
    private static boolean existeDiccionario;
    private static String rutaR;
    private static String factorE;
    private static String nombreD;
    
    /**
     * Contructor por defecto de la clase
     */
    public FuenteDeDatos (){
        this.rutaOrigen = null;
        this.separador = "punto y coma";
        this.formatoDestino = "Excel";
        this.rutaDestino = ".";
        this.visualizaciones = new ArrayList<>();
        this.diccionario = new Diccionario (); 
        this.existeDiccionario = false;
        this.rutaR = null;
        this.factorE = null;
        this.nombreD = "informe";
    }
    
    /**
     * Devuelve el separador
     * @return separador
     */
    public static String getSeparador(){
        return separador;
    }
    
    /**
     * Devuelve la ruta del archivo origen
     * @return ruta del archivo de origen
     */
    public static String getrutaOrigen(){
        return rutaOrigen;
    }
    
    /**
     * Devuelve el formato de destino
     * @return formato de destino
     */
    public static String getformatoDestino(){
        return formatoDestino;
    }
    
    /**
     * Devuelve la ruta de destino
     * @return ruta de destino
     */
    public static String getrutaDestino(){
        return rutaDestino;
    }
    
    /**
     * Devuelve la lista de visualizaciones
     * @return lista de visualizaciones
     */
    public ArrayList<Visualizacion> getVisualizaciones(){
        return (ArrayList<Visualizacion>) visualizaciones.clone();
    }
    
    /**
     * Devuelve el diccionario ya creado
     * @return diccionario ya creado
     */
    public static Diccionario getDiccionario(){
        return diccionario;
    }
    
    /**
     * Devuelve si existe o no diccionario 
     * @return si existe o no diccionario
     */
    public static boolean getExisteD(){
        return existeDiccionario;
    }
    
    /**
     * Actualiza el valor del separador
     * @param sep separador
     */
    public static void setSeparador(String sep){
        separador = sep;
    }
    
    /**
     * Pone a true el indicador de si existe diccionario creado
     */
    public static void setExisteDTrue(){
        existeDiccionario = true;
    }
    
    /**
     * Pone a false el indicador de si existe diccionario creado
     */
    public static void setExisteDFalse(){
        existeDiccionario = false;
    }
    
    /**
     * Actualiza la ruta del archivo de origen
     * @param rorigen ruta de origen
     */
    public static void setrutaOrigen(String rorigen){
        rutaOrigen = rorigen;
    }
    
    /**
     * Actualiza el formato de destino
     * @param fDestino formato de destino
     */
    public static void setformatoDestino(String fDestino){
        formatoDestino = fDestino;
    }
    
    /**
     * Actualiza la ruta de destino
     * @param rDestino ruta de destino
     */
    public static void setrutaDestino (String rDestino){
        rutaDestino = rDestino;
    }
    
    /**
     * Añade una visualizacion a la lista
     * @param vis visualizacion a añadir
     */
    public void añadeVisualizaciones (Visualizacion vis){
        visualizaciones.add(vis);
    }

    
    /**
     * Elimina una visualizacion de la lista
     * @param i indice de la visualizacion a eliminar
     */
    public void eliminaVisualizaciones(int i){
        visualizaciones.remove(i);
    }
    
    /**
     * Actualiza el diccionario almacenado
     * @param dic diccionario
     */
    public static void setDiccionario (Diccionario dic){
        diccionario = dic;
    }
    
    /**
     * Actualiza la ruta de R
     * @param rutar ruta de R
     */
    public static void setRutaR(String rutar){
        rutaR = rutar;
    }
    
    /**
     * Devuelve la ruta de R
     * @return ruta de R
     */
    public static String getRutaR(){
        return rutaR;
    }
    
    /**
     * Actualiza el valor del factor de elevacion
     * @param elevacion factor de elevacion
     */
    public static void setElevacion(String elevacion){
        factorE = elevacion;
    }
    
    /**
     * Devuelve el valor del factor de elevacion
     * @return factor de elevacion
     */
    public static String getElevacion(){
        return factorE;
    }
    
    /**
     * Actualiza el valor del nombre del archivo de destino
     * @param nombreDes nombre del archivo de destino
     */
    public static void setNombreD(String nombreDes){
        nombreD = nombreDes;
    }
    
    /**
     * Devuelve el nombre del archivo de destino
     * @return nombre del archivo de destino
     */
    public static String getNombreD(){
        return nombreD;
    }
    
    
}
