package Otros;

import java.util.ArrayList;

/**
 * Clase auxiliar diccionario
 * @author Raúl Hernansanz Quevedo
 */
public class Diccionario {
    private ArrayList<String> nombres;
    private ArrayList<String> codigos;
    private ArrayList<String> descripciones;
    
    /**
     * Constructor de la clase con valores 
     * @param n lista de nombres de variables
     * @param c lista de codigos de variables
     * @param d lista de descripciones de variables
     */
    public Diccionario (ArrayList<String> n, ArrayList<String> c, ArrayList<String> d){
        this.nombres = n;
        this.codigos = c;
        this.descripciones = d;
    }
    
    /**
     * Constructor por defecto de la clase
     */
    public Diccionario (){
        this.nombres = new ArrayList<> ();
        this.codigos = new ArrayList<> ();
        this.descripciones = new ArrayList<> ();
    }

    /**
     * Devuelve la lista de nombres de variables
     * @return lista de nombres de variables
     */
    public ArrayList<String> getNombres(){
        return this.nombres;
    }
    
    /**
     * Devuelve la lista de codigos de variables
     * @return lista de codigos de las variables
     */
    public ArrayList<String> getCodigos(){
        return this.codigos;
    }
    
    /**
     * Devuelve la lista de descripciones de las variables
     * @return lista de descripciones de las variables
     */
    public ArrayList<String> getDescripciones(){
        return this.descripciones;
    }
    
    /**
     * Añade un nombre de variable a la lista
     * @param nombre nombre de la variable a añadir
     */
    public void añadeNombre(String nombre){
        nombres.add(nombre);
    }
    
    /**
     * Añade un codigo de variable a la lista
     * @param codigo codigo de la variable a añadir
     */
    public void añadeCodigo(String codigo){
        codigos.add(codigo);
    }
    
    /**
     * Añade una descripcion de variable a la lista
     * @param descripcion descripcion de la variable a añadir
     */
    public void añadeDescripcion(String descripcion){
        descripciones.add(descripcion);
    }
    
}
