
package interfazdiccionario;

import Otros.Diccionario;
import java.awt.Point;
import java.util.ArrayList;

/**
 * Vista de creacion del diccionario
 * @author Raúl Hernansanz Quevedo
 */
public class VistaDiccionario extends javax.swing.JFrame {

    private ControladorDiccionario micontrol;

    /**
     * Crea la interfaz para la ventana de creacion de diccionario y se actualiza
     * con las variable que ya estuvieran creadas
     */
    public VistaDiccionario() {
        initComponents();
        micontrol = new ControladorDiccionario(this); 
        micontrol.actualizar();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        campoNombre = new javax.swing.JTextField();
        campoCodigo = new javax.swing.JTextField();
        campoDescripcion = new javax.swing.JTextField();
        botonAñadir = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        botonCancelar = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        botonAceptar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        campoDiccionario = new javax.swing.JTextArea();

        setTitle("Diccionario");
        setLocation(new java.awt.Point(300, 300));
        setPreferredSize(new java.awt.Dimension(900, 364));
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setLayout(new java.awt.GridLayout(1, 5, 5, 0));

        campoNombre.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Nombre Variable", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 13))); // NOI18N
        campoNombre.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                campoNombreMouseClicked(evt);
            }
        });
        jPanel2.add(campoNombre);

        campoCodigo.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Código", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 13))); // NOI18N
        campoCodigo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                campoCodigoMouseClicked(evt);
            }
        });
        jPanel2.add(campoCodigo);

        campoDescripcion.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Descripción", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 13))); // NOI18N
        campoDescripcion.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                campoDescripcionMouseClicked(evt);
            }
        });
        jPanel2.add(campoDescripcion);

        botonAñadir.setBackground(new java.awt.Color(153, 204, 255));
        botonAñadir.setText("AÑADIR");
        botonAñadir.setMinimumSize(new java.awt.Dimension(77, 70));
        botonAñadir.setPreferredSize(new java.awt.Dimension(79, 70));
        botonAñadir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAñadirActionPerformed(evt);
            }
        });
        jPanel2.add(botonAñadir);

        jLabel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setFont(new java.awt.Font("Tahoma", 2, 13)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(156, 156, 156));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("<html><body>Doble click sobre una <br>variable para eliminarla.</body></html> ");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel1.setOpaque(true);
        jPanel2.add(jLabel1);

        jPanel1.add(jPanel2, java.awt.BorderLayout.PAGE_START);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel4.setMinimumSize(new java.awt.Dimension(279, 60));
        jPanel4.setPreferredSize(new java.awt.Dimension(613, 60));
        jPanel4.setLayout(new java.awt.GridLayout(1, 3));

        botonCancelar.setBackground(new java.awt.Color(153, 204, 255));
        botonCancelar.setText("CANCELAR");
        botonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelarActionPerformed(evt);
            }
        });
        jPanel4.add(botonCancelar);

        jSeparator1.setForeground(new java.awt.Color(255, 255, 255));
        jSeparator1.setOpaque(true);
        jPanel4.add(jSeparator1);

        botonAceptar.setBackground(new java.awt.Color(153, 204, 255));
        botonAceptar.setText("ACEPTAR");
        botonAceptar.setMinimumSize(new java.awt.Dimension(87, 70));
        botonAceptar.setPreferredSize(new java.awt.Dimension(87, 70));
        botonAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAceptarActionPerformed(evt);
            }
        });
        jPanel4.add(botonAceptar);

        jPanel3.add(jPanel4, java.awt.BorderLayout.PAGE_END);

        campoDiccionario.setEditable(false);
        campoDiccionario.setColumns(85);
        campoDiccionario.setFont(new java.awt.Font("Monospaced", 0, 16)); // NOI18N
        campoDiccionario.setRows(5);
        campoDiccionario.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Diccionario", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 15))); // NOI18N
        campoDiccionario.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                campoDiccionarioMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(campoDiccionario);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 364, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Captura el evento de pulsar sobre el boton de añadir y llama al controlador
     * @param evt 
     */
    private void botonAñadirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAñadirActionPerformed
        // TODO add your handling code here:
        micontrol.procesaAñadir();
    }//GEN-LAST:event_botonAñadirActionPerformed

    /**
     * Captura el evento de pulsar sobre el boton de aceptar y llama al controlador
     * @param evt 
     */
    private void botonAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAceptarActionPerformed
        // TODO add your handling code here:
        micontrol.procesaAceptar();
    }//GEN-LAST:event_botonAceptarActionPerformed

    /**
     * Captura el evento de pulsar sobre el boton de cancelar y llama al controlador
     * @param evt 
     */
    private void botonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelarActionPerformed
        // TODO add your handling code here:
        micontrol.procesaCancelar();
    }//GEN-LAST:event_botonCancelarActionPerformed

    /**
     * Captura el evento de pulsar sobre el campo de codigo y llama al controlador
     * @param evt 
     */
    private void campoCodigoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_campoCodigoMouseClicked
        // TODO add your handling code here:
        micontrol.limpiaCodigo();
    }//GEN-LAST:event_campoCodigoMouseClicked

    /**
     * Captura el evento de pulsar sobre el campo de nombre de variable y llama al controlador
     * @param evt 
     */
    private void campoNombreMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_campoNombreMouseClicked
        // TODO add your handling code here:
        micontrol.limpiaNombre();
    }//GEN-LAST:event_campoNombreMouseClicked

    /**
     * Captura el evento de pulsar sobre el campo de descripcion y llama al controlador
     * @param evt 
     */
    private void campoDescripcionMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_campoDescripcionMouseClicked
        // TODO add your handling code here:
        micontrol.limpiaDescripcion();
    }//GEN-LAST:event_campoDescripcionMouseClicked

    /**
     * Captura el evento de cerrar la ventana y llama al controlador
     * @param evt 
     */
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // TODO add your handling code here:
        micontrol.procesaCancelar();
    }//GEN-LAST:event_formWindowClosing

    /**
     * Captura el evento de pulsar sobre el campo en el que se muestran las variables
     * obteniendo la posicion relativa del raton y llama al controlador en el caso de que 
     * se produzcan dos clicks seguidos
     * @param evt 
     */
    private void campoDiccionarioMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_campoDiccionarioMouseClicked
        // TODO add your handling code here:
        if(evt.getClickCount()==2){
            Point mousePosition = campoDiccionario.getMousePosition();
            micontrol.eliminaPorPos(mousePosition.x, mousePosition.y);
        }
    }//GEN-LAST:event_campoDiccionarioMouseClicked

    /**
     * Devuelve el nombre de la variable escrito en el campo de texto 
     * @return nombre de la variable
     */
    public String getNombre(){
        return campoNombre.getText();
    }
    
    /**
     * Devuelve el codigo de la variable escrito en el campo de texto
     * @return codigo de la variable
     */
    public String getCodigo(){
        return campoCodigo.getText();
    }
    
    /**
     * Devuelve la descripcion escrita en el campo de texto
     * @return descripcion de la variable
     */
    public String getDescripcion(){
        return campoDescripcion.getText();
    }
    
    /**
     * Limpia los campos de codigo y descripcion ya que una misma variable
     * puede tener diferentes codigos
     */
    public void nuevoRegistro(){
        campoCodigo.setText("");
        campoDescripcion.setText("");
    }
    
    /**
     * Limpia el campo del nombre de la variable
     */
    public void limpiaNombre(){
        campoNombre.setForeground(new java.awt.Color(0, 0, 0));
        campoNombre.setText("");
    }
    
    /**
     * Limpia el campo de codigo de la variable
     */
    public void limpiaCodigo(){
        campoCodigo.setForeground(new java.awt.Color(0, 0, 0));
        campoCodigo.setText("");
    }
    
    /**
     * Limpia el campo de la descripcion de la variable
     */
    public void limpiaDescripcion(){
        campoDescripcion.setForeground(new java.awt.Color(0, 0, 0));
        campoDescripcion.setText("");
    }
    
    /**
     * Muestra error en el campo de nombre
     */
    public void errorNombre(){
        campoNombre.setForeground(new java.awt.Color(255, 0, 0));
        campoNombre.setText("Error");
    }
    
    /**
     * Muestra error en el campo de codigo
     */
    public void errorCodigo(){
        campoCodigo.setForeground(new java.awt.Color(255, 0, 0));
        campoCodigo.setText("Error");
    }
    
    /**
     * Muestra error en el campo de descripcion
     */
    public void errorDescripcion(){
        campoDescripcion.setForeground(new java.awt.Color(255, 0, 0));
        campoDescripcion.setText("Error");
    }
    
    /**
     * Actualiza el campo de texto con los elementos recibidos
     * @param nombres lista de nombres de las variables a mostrar
     * @param codigos lista de codigos de las variables a mostrar
     * @param descripciones lista de descripcones de las variables a mostrar
     */
    public void actualizaDiccionario(ArrayList<String> nombres, ArrayList<String> codigos, ArrayList<String> descripciones){
        campoDiccionario.setText("");
        if(!nombres.isEmpty()){
            for(int i=0;i<nombres.size();i++){
               campoDiccionario.append("Nombre: "+nombres.get(i)+"\t\tCódigo: "+codigos.get(i)+"\tDescripción: "+descripciones.get(i)+"\n"
                       + "---------------------------------------------------------------------------------\n");
            }
        }
        
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAceptar;
    private javax.swing.JButton botonAñadir;
    private javax.swing.JButton botonCancelar;
    private javax.swing.JTextField campoCodigo;
    private javax.swing.JTextField campoDescripcion;
    private javax.swing.JTextArea campoDiccionario;
    private javax.swing.JTextField campoNombre;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    // End of variables declaration//GEN-END:variables
}
