/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package interfazusuario;

import Otros.Visualizacion;
import java.awt.Color;
import java.awt.Point;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;

/**
 * Vista de la ventana principal de la interfaz
 * @author Raúl Hernansanz Quevedo
 */
public class VistaInterfaz extends javax.swing.JFrame {

    private ControladorInterfaz micontrol;

    /**
     * Constructor que crea la interfaz para la ventana de acceso a través de facebook y también el controlador
     * correspondiente y se actualiza con los parametros del archivo de texto y los que ya esten 
     * creados en la fuente de datos
     * @throws IOException excepcion de entrada/salida
     */
    public VistaInterfaz() throws IOException {
        initComponents();
        micontrol = new ControladorInterfaz(this); 
        micontrol.actualizar(getTipoVisualizacion());
        
        micontrol.leefichero();
        micontrol.actualizate();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel9 = new javax.swing.JPanel();
        botonR = new javax.swing.JButton();
        rutaR = new javax.swing.JTextField();
        jPanel7 = new javax.swing.JPanel();
        botonOrigen = new javax.swing.JButton();
        rutaOrigen = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        boxSeparador = new javax.swing.JComboBox<>();
        boxFormato = new javax.swing.JComboBox<>();
        jPanel5 = new javax.swing.JPanel();
        botonDiccionario = new javax.swing.JButton();
        labelDiccionario = new javax.swing.JLabel();
        jPanel8 = new javax.swing.JPanel();
        botonDestino = new javax.swing.JButton();
        rutaDestino = new javax.swing.JTextField();
        labelElevacion = new javax.swing.JTextField();
        labelNombreD = new javax.swing.JTextField();
        botonAceptar = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        boxVisualizacion = new javax.swing.JComboBox<>();
        boxMedida = new javax.swing.JComboBox<>();
        variableRespuesta = new javax.swing.JTextField();
        variableCruce1 = new javax.swing.JTextField();
        variableCruce2 = new javax.swing.JTextField();
        botonAñadir = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        listaVisualizaciones = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Tratamiento de encuestas");
        setLocation(new java.awt.Point(300, 300));
        setResizable(false);

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setLayout(new java.awt.BorderLayout(10, 10));

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Parámetros básicos"));
        jPanel2.setPreferredSize(new java.awt.Dimension(400, 423));
        jPanel2.setLayout(new java.awt.GridLayout(8, 1));

        jPanel9.setBackground(new java.awt.Color(255, 255, 255));
        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Ruta de RScript"));
        jPanel9.setLayout(new java.awt.BorderLayout());

        botonR.setText(". . .");
        botonR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonRActionPerformed(evt);
            }
        });
        jPanel9.add(botonR, java.awt.BorderLayout.LINE_END);

        rutaR.setEditable(false);
        rutaR.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        rutaR.setOpaque(false);
        jPanel9.add(rutaR, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel9);

        jPanel7.setBackground(new java.awt.Color(255, 255, 255));
        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Ruta archivo de datos"));
        jPanel7.setLayout(new java.awt.BorderLayout());

        botonOrigen.setText(". . .");
        botonOrigen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonOrigenActionPerformed(evt);
            }
        });
        jPanel7.add(botonOrigen, java.awt.BorderLayout.LINE_END);

        rutaOrigen.setEditable(false);
        rutaOrigen.setBackground(new java.awt.Color(255, 255, 255));
        rutaOrigen.setFont(new java.awt.Font("Tahoma", 1, 15)); // NOI18N
        jPanel7.add(rutaOrigen, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel7);

        jPanel4.setLayout(new java.awt.GridLayout(1, 2));

        boxSeparador.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "punto y coma", "tabulador", "coma", "espacio" }));
        boxSeparador.setBorder(javax.swing.BorderFactory.createTitledBorder("Separador del archivo"));
        boxSeparador.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boxSeparadorActionPerformed(evt);
            }
        });
        jPanel4.add(boxSeparador);

        boxFormato.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Excel", "Word", "Imagen", "PowerPoint", "HTML" }));
        boxFormato.setBorder(javax.swing.BorderFactory.createTitledBorder("Formato de destino"));
        boxFormato.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boxFormatoActionPerformed(evt);
            }
        });
        jPanel4.add(boxFormato);

        jPanel2.add(jPanel4);

        jPanel5.setBackground(new java.awt.Color(255, 255, 255));
        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Diccionario de datos (opcional)"));
        jPanel5.setLayout(new java.awt.GridLayout(1, 2));

        botonDiccionario.setBackground(new java.awt.Color(153, 204, 255));
        botonDiccionario.setText("Crear o editar Diccionario");
        botonDiccionario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDiccionarioActionPerformed(evt);
            }
        });
        jPanel5.add(botonDiccionario);

        labelDiccionario.setFont(new java.awt.Font("Tahoma", 1, 17)); // NOI18N
        labelDiccionario.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        labelDiccionario.setText("NO CREADO");
        jPanel5.add(labelDiccionario);

        jPanel2.add(jPanel5);

        jPanel8.setBackground(new java.awt.Color(255, 255, 255));
        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Ruta archivo de destino (opcional)"));
        jPanel8.setLayout(new java.awt.BorderLayout());

        botonDestino.setText(". . .");
        botonDestino.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDestinoActionPerformed(evt);
            }
        });
        jPanel8.add(botonDestino, java.awt.BorderLayout.LINE_END);

        rutaDestino.setEditable(false);
        rutaDestino.setBackground(new java.awt.Color(255, 255, 255));
        rutaDestino.setFont(new java.awt.Font("Tahoma", 1, 15)); // NOI18N
        jPanel8.add(rutaDestino, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel8);

        labelElevacion.setBorder(javax.swing.BorderFactory.createTitledBorder("Introduce factor de elevación"));
        jPanel2.add(labelElevacion);

        labelNombreD.setBorder(javax.swing.BorderFactory.createTitledBorder("Nombre archivo destino"));
        labelNombreD.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                labelNombreDMouseClicked(evt);
            }
        });
        jPanel2.add(labelNombreD);

        botonAceptar.setBackground(new java.awt.Color(153, 204, 255));
        botonAceptar.setText("ACEPTAR");
        botonAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAceptarActionPerformed(evt);
            }
        });
        jPanel2.add(botonAceptar);

        jPanel1.add(jPanel2, java.awt.BorderLayout.LINE_START);

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));
        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Propiedades Visualizaciones"));
        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel6.setPreferredSize(new java.awt.Dimension(250, 502));
        jPanel6.setLayout(new java.awt.GridLayout(7, 1));

        jLabel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setFont(new java.awt.Font("Tahoma", 2, 13)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(156, 156, 156));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setLabelFor(listaVisualizaciones);
        jLabel1.setText("<html><body>Haga doble click sobre una <br>visualización para eliminarla.</body></html> ");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel1.setOpaque(true);
        jPanel6.add(jLabel1);

        boxVisualizacion.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Gráfico de barras horizontales", "Gráfico de barras verticales", "Gráfico de sectores", "Tabla" }));
        boxVisualizacion.setBorder(javax.swing.BorderFactory.createTitledBorder("Tipo visualización"));
        boxVisualizacion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boxVisualizacionActionPerformed(evt);
            }
        });
        jPanel6.add(boxVisualizacion);

        boxMedida.setBorder(javax.swing.BorderFactory.createTitledBorder("Medida representada"));
        jPanel6.add(boxMedida);

        variableRespuesta.setBorder(javax.swing.BorderFactory.createTitledBorder("Variable respuesta"));
        variableRespuesta.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                variableRespuestaMouseClicked(evt);
            }
        });
        jPanel6.add(variableRespuesta);

        variableCruce1.setBorder(javax.swing.BorderFactory.createTitledBorder("Variable cruce 1"));
        variableCruce1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                variableCruce1MouseClicked(evt);
            }
        });
        jPanel6.add(variableCruce1);

        variableCruce2.setText("Opcional");
        variableCruce2.setBorder(javax.swing.BorderFactory.createTitledBorder("Variable cruce 2"));
        variableCruce2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                variableCruce2MouseClicked(evt);
            }
        });
        jPanel6.add(variableCruce2);

        botonAñadir.setBackground(new java.awt.Color(153, 204, 255));
        botonAñadir.setText("AÑADIR");
        botonAñadir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAñadirActionPerformed(evt);
            }
        });
        jPanel6.add(botonAñadir);

        jPanel3.add(jPanel6, java.awt.BorderLayout.LINE_START);

        listaVisualizaciones.setEditable(false);
        listaVisualizaciones.setColumns(20);
        listaVisualizaciones.setFont(new java.awt.Font("Monospaced", 0, 15)); // NOI18N
        listaVisualizaciones.setRows(5);
        listaVisualizaciones.setBorder(javax.swing.BorderFactory.createTitledBorder("Lista visualizaciones"));
        listaVisualizaciones.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaVisualizacionesMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(listaVisualizaciones);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 983, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 483, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Captura el evento de pulsar sobre el combo box del separador y llama a su controlador
     * @param evt 
     */
    private void boxSeparadorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boxSeparadorActionPerformed
        // TODO add your handling code here:
        micontrol.procesaSeparador();
    }//GEN-LAST:event_boxSeparadorActionPerformed

    /**
     * Captura el evento de pulsar sobre el combo box del formato de destino y llama a su controlador
     * @param evt 
     */
    private void boxFormatoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boxFormatoActionPerformed
        // TODO add your handling code here:
        micontrol.procesaFormatoDestino();
    }//GEN-LAST:event_boxFormatoActionPerformed

    /**
     * Captura el evento de pulsar sobre el botón de creación de diccionario y llama a su controlador
     * @param evt 
     */
    private void botonDiccionarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDiccionarioActionPerformed
        // TODO add your handling code here:
        micontrol.procesaCreaDiccionario();
    }//GEN-LAST:event_botonDiccionarioActionPerformed

    /**
     * Captura el evento de pulsar sobre el boton de aceptar y llama a su controlador
     * @param evt 
     */
    private void botonAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAceptarActionPerformed
        try {
            // TODO add your handling code here:
            micontrol.procesaAceptar();
        } catch (IOException ex) {
            Logger.getLogger(VistaInterfaz.class.getName()).log(Level.SEVERE, null, ex);
        }
        //micontrol.prueba();

    }//GEN-LAST:event_botonAceptarActionPerformed

    /**
     * Captura el evento de pulsar sobre el combo box del tipo de visualizacion y llama a su controlador
     * @param evt 
     */
    private void boxVisualizacionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boxVisualizacionActionPerformed
        // TODO add your handling code here:
        micontrol.actualizar(getTipoVisualizacion());
    }//GEN-LAST:event_boxVisualizacionActionPerformed

    /**
     * Captura el evento de pulsar sobre el boton de añadir visualizacion y llama a su controlador
     * @param evt 
     */
    private void botonAñadirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAñadirActionPerformed
        // TODO add your handling code here:
        micontrol.procesaAñadir();
    }//GEN-LAST:event_botonAñadirActionPerformed

    /**
     * Captura el evento de pulsar sobre el campo de la segunda variable de cruce y llama a su controlador
     * @param evt 
     */
    private void variableCruce2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_variableCruce2MouseClicked
        // TODO add your handling code here:
        micontrol.limpiaCruce2();
    }//GEN-LAST:event_variableCruce2MouseClicked

    /**
     * Captura el evento de pulsar sobre el campo de la variable respuesta y llama a su controlador
     * @param evt 
     */
    private void variableRespuestaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_variableRespuestaMouseClicked
        // TODO add your handling code here:
        micontrol.limpiaRespuesta();
    }//GEN-LAST:event_variableRespuestaMouseClicked

    /**
     * Captura el evento de pulsar sobre el campo de la primera variable de cruce y llama a su controlador
     * @param evt 
     */
    private void variableCruce1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_variableCruce1MouseClicked
        // TODO add your handling code here:
        micontrol.limpiaCruce1();
    }//GEN-LAST:event_variableCruce1MouseClicked

    /**
     * Captura el evento de pulsar sobre el boton para introducir la ruta del archivo origen y llama a su controlador
     * @param evt 
     */
    private void botonOrigenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonOrigenActionPerformed
        // TODO add your handling code here:
        rutaOrigen.setForeground(Color.black);
        micontrol.procesaRutaOrigen(this);
        
    }//GEN-LAST:event_botonOrigenActionPerformed

    /**
     * Captura el evento de pulsar sobre el boton para introducir la ruta de destino y llama a su controlador
     * @param evt 
     */
    private void botonDestinoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDestinoActionPerformed
        // TODO add your handling code here:
        micontrol.procesaRutaDestino(this);
    }//GEN-LAST:event_botonDestinoActionPerformed

    /**
     * Captura el evento de pulsar sobre el campo del nombre del archivo de destino y llama a su controlador
     * @param evt 
     */
    private void labelNombreDMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_labelNombreDMouseClicked
        // TODO add your handling code here:
        micontrol.limpiaElevacion();
    }//GEN-LAST:event_labelNombreDMouseClicked

    /**
     * Captura el evento de hacer doble click sobre una visualizacion, captura la posicion y llama a su controlador
     * @param evt 
     */
    private void listaVisualizacionesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaVisualizacionesMouseClicked
        // TODO add your handling code here:
        if(evt.getClickCount()==2){
            Point mousePosition = listaVisualizaciones.getMousePosition();
            micontrol.eliminaPorPos(mousePosition.x, mousePosition.y);
        }
        
    }//GEN-LAST:event_listaVisualizacionesMouseClicked

    /**
     * Captura el evento de pulsar el boton para introducir la ruta de R y llama a su controlador
     * @param evt 
     */
    private void botonRActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonRActionPerformed
        // TODO add your handling code here:
        micontrol.procesaRutaR(this);
    }//GEN-LAST:event_botonRActionPerformed

    /**
     * Devueve el separador seleccionado
     * @return separador seleccionado
     */
    public String getSeparador(){
        return (String) boxSeparador.getSelectedItem();
    }
    
    /**
     * Devueve el formato de destino seleccionado
     * @return formato de destino seleccionado
     */
    public String getFormatoDestino(){
        return (String) boxFormato.getSelectedItem();
    }
    
    /**
     * Devueve la ruta del archivo de origen seleccionada
     * @return ruta del archivo de origen seleccionada
     */
    public String getRutaOrigen(){
        return rutaOrigen.getText();
    }
    
    /**
     * Devueve la ruta de destino seleccionada
     * @return ruta de destino seleccionada
     */
    public String getRutaDestino(){
        return rutaDestino.getText();
    }
    
    /**
     * Devueve el tipo de visualizacion seleccionado
     * @return tipo de visualizacion seleccionado
     */
    public String getTipoVisualizacion(){
        return (String) boxVisualizacion.getSelectedItem();
    }
    
    /**
     * Devueve la medida seleccionada
     * @return medida seleccionada
     */
    public String getMedida(){
        return (String) boxMedida.getSelectedItem();
    }
    
    /**
     * Devueve la variable respuesta seleccionada
     * @return variable respuesta seleccionada
     */
    public String getVrespuesta(){
        return variableRespuesta.getText();
    }
    
    /**
     * Devueve la primera variable de cruce seleccionada
     * @return primera variable de cruce seleccionada
     */
    public String getVcruce1(){
        return variableCruce1.getText();
    }

    /**
     * Devueve la segunda variable de cruce seleccionada
     * @return segunda variable de cruce seleccionada
     */
    public String getVcruce2(){
        return variableCruce2.getText();
    }
    
    /**
     * Devueve el factor de elevacion seleccionado
     * @return factor de elevacion seleccionado
     */
    public String getElevacion(){
        return labelElevacion.getText();
    }
    
    /**
     * Devueve el nombre destino seleccionado
     * @return nombre destino seleccionado
     */
    public String getNombreD(){
        return labelNombreD.getText();
    }
    
    /**
     * Actualiza el combo box de medidas con lo obtenido del archivo de texto
     * @param medidas lista de medidas obtenida del archivo de texto
     */
    public void setMedidas(String [] medidas){
        boxMedida.setModel(new javax.swing.DefaultComboBoxModel(medidas));
    }
    
    /**
     * Actualiza el campo del factor de elevacion en caso de que ya exista uno
     * en la fuente de datos
     * @param factor factor de elevacion
     */
    public void setElevacion(String factor){
        labelElevacion.setText(factor);
    }
    
    /**
     * Actualiza el nombre de destino en caso de que ya exista uno
     * @param nombreD nombre del archivo de destino
     */
    public void setNombreD(String nombreD){
        labelNombreD.setText(nombreD);
    }
    
    /**
     * Actualiza la ruta de R en caso de que ya exista una
     * @param ruta ruta de R
     */
    public void setRutaR(String ruta){
        rutaR.setText(ruta);
    }
    
    /**
     * Devuelve la ruta de R seleccionada
     * @return ruta de R seleccionada
     */
    public String getRutaR(){
        return rutaR.getText();
    }
    
    /**
     * Muestra que existe un error en el campo de la ruta de R
     */
    public void errorR(){
        rutaR.setForeground(new java.awt.Color(255, 0, 0));
        rutaR.setText("Introduce la ruta de R");
    }
    
    /**
     * Actualiza las visualizaciones que se estan mostrando actualmente
     * @param visActuales visualizaciones incluidas en la fuente de datos
     */
    public void actualizaVisualizaciones(ArrayList<Visualizacion> visActuales){
        if(visActuales.isEmpty()){
            listaVisualizaciones.setText("");    
        } else {
            listaVisualizaciones.setText("");
            for (int i = 0; i < visActuales.size(); i++){
                listaVisualizaciones.append(" TIPO: "+visActuales.get(i).getTipo()+"\n"+
                                            " MEDIDA: "+visActuales.get(i).getMedida()+"\n"+
                                            " VARIABLE RESPUESTA: "+visActuales.get(i).getvrespuesta()+"\n"+
                                            " VARIABLE CRUCE 1: "+visActuales.get(i).getvCruceUno()+"\n"+   
                                            " VARIABLE CRUCE 2: "+visActuales.get(i).getvCruceDos()+"\n"+
                                            " -------------------------------------------------------\n");
            }
        }
    }
    
    /**
     * Actualiza la ruta del archivo de origen en caso de que ya exista una
     * @param ruta ruta del archivo de origen
     */
    public void setRutaOrigen(String ruta){
        rutaOrigen.setText(ruta);
    }
    
    /**
     * Actualiza el separador en caso de que ya exista una
     * @param separador separador del archivo de datos
     */
    public void setSeparador(String separador){
        if (separador.equals("punto y coma")){
            boxSeparador.setSelectedIndex(0); 
        }
        if(separador.equals("tabulador")){
            boxSeparador.setSelectedIndex(1);       
        }
        if(separador.equals("coma")){
            boxSeparador.setSelectedIndex(2);
        }
        if(separador.equals("espacio")){
            boxSeparador.setSelectedIndex(3);
        }  
    }
    
    /**
     * Actualiza el formato de destino en caso de que ya exista una
     * @param destino formato de destino
     */
    public void setDestino(String destino){
        if (destino.equals("Excel")){
            boxFormato.setSelectedIndex(0); 
        }
        if(destino.equals("Word")){
            boxFormato.setSelectedIndex(1);       
        }
        if(destino.equals("Imagen")){
            boxFormato.setSelectedIndex(2);
        }
        if(destino.equals("PowerPoint")){
            boxFormato.setSelectedIndex(3);
        }
        if(destino.equals("HTML")){
            boxFormato.setSelectedIndex(4);
        }
    }
    
    /**
     * Actualiza la ruta de destino en caso de que ya exista una
     * @param ruta ruta de destino
     */
    public void setRutaDestino(String ruta){
        rutaDestino.setText(ruta);
    }
    
    /**
     * Limpia el campo de la segunda variable de cruce
     */
    public void limpiaCruce2(){
        variableCruce2.setText("");
    }
    
    /**
     * Limpia el campo de la variable respuesta
     */
    public void limpiaRespuesta(){
        variableRespuesta.setForeground(new java.awt.Color(0, 0, 0));
        variableRespuesta.setText("");
    }
    
    /**
     * Limpia el campo de la primera variable de cruce
     */
    public void limpiaCruce1(){
        variableCruce1.setForeground(new java.awt.Color(0, 0, 0));
        variableCruce1.setText("");
    }
    
    /**
     * Limpia el campo del factor de elevacion
     */
    public void limpiaElevacion(){
        labelNombreD.setForeground(new java.awt.Color(0, 0, 0));
        labelNombreD.setText("");
    }
    
    /**
     * Muestra error en el campo de la variable respuesta
     */
    public void errorRespuesta(){
        variableRespuesta.setForeground(new java.awt.Color(255, 0, 0));
        variableRespuesta.setText("Falta la variable respuesta");
    }
    
    /**
     * Muestra error en el campo de la primera variable de cruce
     */
    public void errorCruce1(){
        variableCruce1.setForeground(new java.awt.Color(255, 0, 0));
        variableCruce1.setText("Falta la variable de cruce");
    }
    
    /**
     * Muestra error en el campo del factor de elevacion
     */
    public void errorElevacion(){
        labelNombreD.setForeground(new java.awt.Color(255, 0, 0));
        labelNombreD.setText("Introduce factor de elevacion");
    }
   
    /**
     * Muestra error en el campo en el que se muestra las visualizaciones
     */
    public void errorVisualizaciones(){
        listaVisualizaciones.setForeground(Color.red);
        listaVisualizaciones.setText("Introduce alguna visualizacion");
    }
    
    /**
     * Muestra error en el campo de la ruta de origen
     */
    public void errorRutaOrigen(){
        rutaOrigen.setForeground(Color.red);
        rutaOrigen.setText("Introduce ruta origen");
    }
    
    /**
     * Actualiza la etiqueta de existencia de diccionario en el caso de que exista
     */
    public void hayDiccionario(){
        labelDiccionario.setText("SÍ CREADO");
    }
    
    /**
     * Deshabilita el campo de la segunda variable de cruce 
     */
    public void deshabilitaCruce(){
        variableCruce2.setText("");
        variableCruce2.disable();
    }
    
    /**
     * Habilita el campo de la primera variable de cruce
     */
    public void habilitaCruce(){
        variableCruce2.enable();
    }
    
    /**
     * Actualiza los combo box de los formatos, separadores y tipos de visualizacion
     * en funcion de lo que haya en el archivo de texto
     * @param formatos lista de formatos
     * @param separadores lista de separadores
     * @param visualizaciones lista de tipos de visualizaciones
     */
    public void componentesFichero(String[]formatos, String[]separadores, String[]visualizaciones){
        boxFormato.setModel(new javax.swing.DefaultComboBoxModel(formatos));
        boxSeparador.setModel(new javax.swing.DefaultComboBoxModel(separadores));
        boxVisualizacion.setModel(new javax.swing.DefaultComboBoxModel(visualizaciones));
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAceptar;
    private javax.swing.JButton botonAñadir;
    private javax.swing.JButton botonDestino;
    private javax.swing.JButton botonDiccionario;
    private javax.swing.JButton botonOrigen;
    private javax.swing.JButton botonR;
    private javax.swing.JComboBox<String> boxFormato;
    private javax.swing.JComboBox<String> boxMedida;
    private javax.swing.JComboBox<String> boxSeparador;
    private javax.swing.JComboBox<String> boxVisualizacion;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel labelDiccionario;
    private javax.swing.JTextField labelElevacion;
    private javax.swing.JTextField labelNombreD;
    private javax.swing.JTextArea listaVisualizaciones;
    private javax.swing.JTextField rutaDestino;
    private javax.swing.JTextField rutaOrigen;
    private javax.swing.JTextField rutaR;
    private javax.swing.JTextField variableCruce1;
    private javax.swing.JTextField variableCruce2;
    private javax.swing.JTextField variableRespuesta;
    // End of variables declaration//GEN-END:variables
}
