package maquinaEstados;
import Modelo.*;
import interfazPortada.VistaPortada;
import interfazdiccionario.VistaDiccionario;
import interfazusuario.VistaGenerando;
import interfazusuario.VistaInterfaz;
import interfazusuario.VistaWarning;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.Timer;
/**
 * Maquina de estados que cambiara entre vistas
 * @author Raúl Hernansanz Quevedo
 */
public class maquinaEstados {
    private static FuenteDeDatos mimodelo = new FuenteDeDatos();
    private static JFrame currentState; 
    private static JFrame war;
    private static JFrame gen;
    
    
    /**
     * Metodo inicial que arranca la aplicacion abriendo la vetana de la portada
     */
    public static void start() {
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                currentState = new VistaPortada();
                currentState.setVisible(true);

            }
    });}
    
    /**
     * Cambia a la ventana de creacion de diccionario
     */
    public static void diccionario() {
       currentState.setVisible(false);
       currentState.dispose(); 
       
       //transición
       java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                currentState = new VistaDiccionario();
                currentState.setVisible(true);
            }
        });
    }
    
    /**
     * Cambia a la ventana principal de la aplicacion
     */
    public static void interfaz() {
        currentState.setVisible(false); 
        currentState.dispose();
               
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    currentState = new VistaInterfaz();
                } catch (IOException ex) {
                    Logger.getLogger(maquinaEstados.class.getName()).log(Level.SEVERE, null, ex);
                }
                currentState.setVisible(true);
            }
    });}
    
    /**
     * Cambia a la ventana de la portada de la aplicacion
     */
    public static void portada() {
        currentState.setVisible(false); 
        currentState.dispose();
               
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                currentState = new VistaPortada();
                currentState.setVisible(true);
            }
    });}
    
    /**
     * Abre la ventana de alerta
     */
    public static void warningON() {
        currentState.setVisible(false); 
               
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                war = new VistaWarning();
                war.setVisible(true);
            }
    });}
    
    /**
     * Cierra la ventana de alerta
     */
    public static void warningOFF() {
        currentState.setVisible(true);
        war.dispose();
    }
    
    /**
     * Devuelve el modelo actual
     * @return modelo, o fuente de datos
     */
    public static FuenteDeDatos getModelo(){
        return mimodelo;
    }
    
    /**
     * Metodo que muestra la ventana de espera, ocultando la de la interfaz y, 
     * tras 20 segundos, la cierra y vuelve a mostrar la de la interfaz
     */
    public static void generando(){
        currentState.setVisible(false);
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                gen = new VistaGenerando();
                gen.setVisible(true);
            }
    });
    Timer timer = new Timer (25000, new ActionListener ()
    {
    public void actionPerformed(ActionEvent e)
    {
        currentState.setVisible(true);
        gen.dispose();
    }
    });
    timer.start();
 
    }
    
}
